//+------------------------------------------------------------------+
//|                                           Volatility quality.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_width1  3
#property indicator_width2  3
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int             Length    = 5;
extern ENUM_MA_METHOD  Method    = 3;
extern int    Smoothing          = 1;
extern double FilterInPips       = 2.0;
extern bool   arrowsVisible      = false;
extern string arrowsIdentifier   = "VQnrpArrows";
extern color  arrowsUpColor      = DeepSkyBlue;
extern color  arrowsDnColor      = Red;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;

//
//
//
//
//

double UpBuffer[];
double DnBuffera[];
double DnBufferb[];
double SumVQ[];
double trend[];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,DnBuffera); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnBufferb); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,SumVQ);    
      SetIndexBuffer(3,trend);
      Smoothing = MathMax(Smoothing,1);      

   IndicatorShortName(timeFrameToString(TimeFrame)+" Volatility Quality");
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMax(Bars-counted_bars,3*TimeFrame/Period());
         double pipMultiplier = MathPow(10,_Digits%2);

   //
   //
   //
   //
   //

   for (int i=limit; i>= 0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         double MH  = iMA(NULL,TimeFrame,Length,0,Method,PRICE_HIGH, y);
         double ML  = iMA(NULL,TimeFrame,Length,0,Method,PRICE_LOW,  y);
         double MO  = iMA(NULL,TimeFrame,Length,0,Method,PRICE_OPEN, y);
         double MC  = iMA(NULL,TimeFrame,Length,0,Method,PRICE_CLOSE,y);
         double MC1 = iMA(NULL,TimeFrame,Length,0,Method,PRICE_CLOSE,y+Smoothing);
      
         //
         //
         //
         //
         //
      
         if (MH != ML)
               double VQ = MathAbs(((MC-MC1) / MathMax(MH-ML,MathMax(MH-MC1,MC1-ML)) + (MC-MO)/(MH-ML)) * 0.5) * ((MC-MC1 + (MC-MO)) * 0.5);
         else         VQ = 0.00;
         SumVQ[i] = SumVQ[i+1] + VQ;

         if (FilterInPips > 0) if (MathAbs(SumVQ[i]-SumVQ[i+1]) < FilterInPips*pipMultiplier*Point) SumVQ[i] = SumVQ[i+1];

         //
         //
         //
         //
         //

         UpBuffer[i]  = SumVQ[i];
         DnBuffera[i] = EMPTY_VALUE;
         DnBufferb[i] = EMPTY_VALUE;
         trend[i]     = trend[i+1];
            if (SumVQ[i] > SumVQ[i+1]) trend[i] =  1;
            if (SumVQ[i] < SumVQ[i+1]) trend[i] = -1;
            if (trend[i] == 1)         DnBuffera[i] = 1;
            if (trend[i] ==-1)         DnBufferb[i] = 1;
               manageArrow(i);
      }
      manageAlerts();
      return(0);
   }      
   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible )
   {
         deleteArrow(Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i] == 1) drawArrow(i,arrowsUpColor,241,false);
            if (trend[i] ==-1) drawArrow(i,arrowsDnColor,242,true);
         }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(TimeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," VQ trend changed to  ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"VQ nrp "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}